/*
 * csum.c  -dlevette
 *
 * Standard checksum routine
*/
#include <stdio.h>
#include <stdlib.h>


u_short calc_csum(u_char *data, int len)
{
	u_long sum = 0;
	u_short *ip_head = (u_short *)data;

	while( len > 1 ){
		sum += *((u_short *)ip_head)++;
		len -= 2;
	}

	/* Add leftover byte */
	if(len > 0)
		sum += (u_short) *(u_char *)ip_head;
	
	/* Make 16 bit */
	while( sum >> 16 )
		sum = (sum >> 16) + (sum & 0xffff);
		
	return ~sum; 
}
