/*
 * help.c  -dlevette
 *
 * Help text and error routines
 *
*/
#include <stdio.h>

void help()
{
	char help[] =
	"\n"
	"Packet Manipulator\n"
	"\n"
	"usage: pkmap {mode} [mode opts] {ip options} {ether options}\n"
	"\n"
	"To get help for each mode, call the required mode option followed by the help option\n"
	"\n"
	"  -h : Display help text\n"
	"\n"
	"Modes:\n"
	"  -P : IP mode\n"
	"  -T : TCP mode\n"
	"  -U : UDP mode\n"
	"  -M : ICMP mode\n"
	"  -A : ARP mode\n"
	"\n";
	
	printf(help);
}

void ip_help()
{
	char help[] =
	"\n"
	"Packet Manipulator - IP Help\n"
	"\n"
	"usage: pkmap -P [ip opts] {ether options}\n"
	"\n"
	"Options:\n"
	"  -i [interface]\n"
	"  -n [Number of packets to send {default is one}]\n"
	"  -C [Config file] -All options can be specified in this file\n"
	"  -W [Config file to write to]\n"
	"  -h : Display this help text\n"
	"\n"
	"IP Options:\n"
	"  -S [Source IP]\n"
	"  -D [Dest IP]\n"
	"  -I [IP ID]\n"
	"  -F [Fragmentation opts]\n"
	"	r [Set reserved bit]\n"
	"	d [Set the 'dont fragment' bit]\n"
	"	m [Set the 'more fragments' bit]\n"
	"  -L [Time to live {max 255}]\n"
	"\n"
	"Etherlink options:\n"
	"  -Z [Source MAC]\n"
	"  -Y [Dest MAC]\n"
	"  -E [Ether Type] (please consult man page for types)\n"
	"\n"
	"Payload Options:\n"
	"  -p 'file' : File containing a payload\n"
	"       r    : r can be provided instead of a file, in which case\n"
	"	      a payload will be randomly generated for the packet.\n"
	"\n";
	
	printf(help);
}

void tcp_help()
{
	char help[] =
	"\n"
	"Packet Manipulator - TCP Help\n"
	"\n"
	"usage: pkmap -T [tcp opts] {ip options} {ether options}\n"
	"\n"
	"Global Options:\n"
	"  -i [interface]\n"
	"  -n [Number of packets to send {default is one}]\n"
	"  -C [Config file] -All options can be specified in this file\n"
	"  -W [Config file to write to]\n"
	"  -h : Display this help text\n"
	"\n"
	"  -T : tcp mode\n"
	"	-s [Source port]\n"
	"	-d [Dest port]\n"
	"	-f [Tcp Flags] {F S R P A U} these can be combined on the command line\n"
	"	-w [Window Size] {Default value is 512}\n"
	"	-u [Priority pointer] {0-3}\n"
	"\n"
	"IP Options:\n"
	"  -S [Source IP]\n"
	"  -D [Dest IP]\n"
	"  -I [IP ID]\n"
	"  -F [Fragmentation opts]\n"
	"	r [Set reserved bit]\n"
	"	d [Set the 'dont fragment' bit]\n"
	"	m [Set the 'more fragments' bit]\n"
	"  -L [Time to live {max 255}]\n"
	"\n"
	"Etherlink options:\n"
	"  -Z [Source MAC]\n"
	"  -Y [Dest MAC]\n"
	"  -E [Ether Type] (please consult man page for types)\n"
	"\n"
	"Payload Options:\n"
	"  -p 'file' : File containing a payload\n"
	"       r    : r can be provided instead of a file, in which case\n"
	"	      a payload will be randomly generated for the packet.\n"
	"\n";
	
	printf(help);
}

void udp_help()
{
	char help[] =
	"\n"
	"Packet Manipulator - UDP Help\n"
	"\n"
	"usage: pkmap -U [udp opts] {ip options} {ether options}\n"
	"\n"
	"Options:\n"
	"  -i [interface]\n"
	"  -n [Number of packets to send {default is one}]\n"
	"  -C [Config file] -All options can be specified in this file\n"
	"  -W [Config file to write to]\n"
	"  -h : Display this help text\n"
	"\n"
	"  -U : udp mode\n"
	"	-s [Source port]\n"
	"	-d [Dest port]\n"
	"\n"
	"IP Options:\n"
	"  -S [Source IP]\n"
	"  -D [Dest IP]\n"
	"  -I [IP ID]\n"
	"  -F [Fragmentation opts]\n"
	"	r [Set reserved bit]\n"
	"	d [Set the 'dont fragment' bit]\n"
	"	m [Set the 'more fragments' bit]\n"
	"  -L [Time to live {max 255}]\n"
	"\n"
	"Etherlink options:\n"
	"  -Z [Source MAC]\n"
	"  -Y [Dest MAC]\n"
	"  -E [Ether Type] (please consult man page for types)\n"
	"\n"
	"Payload Options:\n"
	"  -p 'file' : File containing a payload\n"
	"       r    : r can be provided instead of a file, in which case\n"
	"	      a payload will be randomly generated for the packet.\n"
	"\n";
	
	printf(help);
}

void icmp_help()
{
	char help[] =
	"\n"
	"Packet Manipulator - ICMP Help\n"
	"\n"
	"usage: pkmap -M [icmp opts] {ip options} {ether options}\n"
	"\n"
	"Options:\n"
	"  -i [interface]\n"
	"  -n [Number of packets to send {default is one}]\n"
	"  -C [Config file] -All options can be specified in this file\n"
	"  -W [Config file to write to]\n"
	"  -h : Display this help text\n"
	"\n"
	"  -M : icmp mode\n"
	"       -t [IMCP type]\n"
	"       -m [IMCP mode]\n"
	"\n"
	"IP Options: \n"
	"  -S [Source IP]\n"
	"  -D [Dest IP]\n"
	"  -I [IP ID]\n"
	"  -F [Fragmentation opts]\n"
	"	r [Set reserved bit]\n"
	"	d [Set the 'dont fragment' bit]\n"
	"	m [Set the 'more fragments' bit]\n"
	"  -L [Time to live {max 255}]\n"
	"\n"
	"Etherlink options:\n"
	"  -Z [Source MAC]\n"
	"  -Y [Dest MAC]\n"
	"  -E [Ether Type] (please consult man page for types)\n"
	"\n"
	"Payload Options:\n"
	"  -p 'file' : File containing a payload\n"
	"       r    : r can be provided instead of a file, in which case\n"
	"	      a payload will be randomly generated for the packet.\n"
	"\n";
	
	printf(help);
}

void arp_help()
{
	char help[] =
	"\n"
	"Packet Manipulator - ARP Help\n"
	"\n"
	"usage: pkmap -A [rarp/arp opts] {ether options}\n"
	"\n"
	"Options:\n"
	"  -i [interface]\n"
	"  -n [Number of packets to send {default is one}]\n"
	"  -C [Config file] -All options can be specified in this file\n"
	"  -W [Config file to write to]\n"
	"  -h : Display this help text\n"
	"\n"
	"  -A : arp mode\n"
	"       -o [Arp type]\n"
	"       -g [Sender IP]\n"
	"       -j [Target IP]\n"
	"       -G [Sender MAC]\n"
	"       -J [Target MAC]\n"
	"\n"
	"Etherlink options:\n"
	"  -Z [Source MAC]\n"
	"  -Y [Dest MAC]\n"
	"  -E [Ether Type] (please consult man page for types)\n"
	"\n"
	"Payload Options:\n"
	"  -p 'file' : File containing a payload\n"
	"       r    : r can be provided instead of a file, in which case\n"
	"	      a payload will be randomly generated for the packet.\n"
	"\n";
	
	printf(help);
}
