/*
 * raw_socks.c  -dlevette
 *
 * Raw socket thingimijigs 
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>

#include <net/if.h>
#include <sys/ioctl.h>
#include <linux/if_packet.h>
#include <net/ethernet.h>
#include <netinet/in.h>

#include "raw_stuff.h"

int open_raw_sock(int proto)
{
	int rsock = 0;

	if( (rsock= socket(AF_PACKET, SOCK_RAW, htons(proto) )) == -1)
		error_msg("Unable to open raw socket. \n");
	return rsock;
}

int sock_to_iface(char *iface, int rsock, int proto)
{
	struct sockaddr_ll sll;
	struct ifreq ifr;
		
	if( (rsock= socket(AF_PACKET, SOCK_RAW, htons(proto) )) == -1)
		error_msg("Unable to open raw socket. \n");

	memset(&ifr, 0, sizeof(ifr));
	strncpy(ifr.ifr_name, iface, IF_NAMESIZE);
	if((ioctl(rsock, SIOCGIFINDEX, &ifr)) < 0 )
		error_msg("Unable to retrive interface index. \n");

	memset(&sll, 0, sizeof(sll));
	sll.sll_family = AF_PACKET;
	sll.sll_ifindex = ifr.ifr_ifindex;
	sll.sll_protocol = htons(proto);

	if(bind(rsock, (struct sockaddr *)&sll, sizeof(sll)) == -1)
		perror("Unable to bind to interface. \n");
	
	return rsock;
}

int bind_raw_local(int rsock, int PORT, int proto)
{
  	struct sockaddr_in local;
		
	if( (rsock= socket(AF_INET, SOCK_RAW, htons(proto) )) == -1)
		error_msg("Unable to open raw socket. \n");

	int one = 1;
        const int *val = &one;
 	if((setsockopt(rsock, IPPROTO_IP,IP_HDRINCL,val,sizeof(one))) == -1 )
		perror("Unable to setsockopt's");

	/*fill sockaddr_in with local address info*/
 	memset( &(local.sin_zero), 0, sizeof(local));
 	local.sin_family = AF_INET;
  	local.sin_port   = htons(PORT);
 	local.sin_addr.s_addr = INADDR_ANY;

  	/*bind address info to socket*/
 	if( bind(rsock, (struct sockaddr *)&local, sizeof(struct sockaddr)) -1 ){
		perror("Unable to bind to local address");}
	
	return rsock;
}

int raw_connect(int rsock, char *REMOTE_ADDR, int PORT, int proto)
{
  	struct sockaddr_in remote;	
	
	if( (rsock= socket(AF_INET, SOCK_RAW, htons(proto) )) == -1)
		error_msg("Unable to open raw socket. \n");
	
	int one = 1;
        const int *val = &one;
 	if((setsockopt(rsock, IPPROTO_IP,IP_HDRINCL,val,sizeof(one))) == -1 )
		perror("Unable to setsockopt's\n");

	memset( &(remote.sin_zero), 0, sizeof(remote));
  	remote.sin_family = AF_INET;
  	remote.sin_port   = htons(PORT);
  	remote.sin_addr.s_addr = inet_addr(REMOTE_ADDR);

  	if( connect(rsock, (struct sockaddr *)&remote, sizeof(struct sockaddr)) == -1)
    		error_msg("Unable to connect() to target\n");
   
  	return rsock;
}
